// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_RENDERERS_OPENGL_LIB_VERTEX_ARRAY_H
#define FENNEC_RENDERERS_OPENGL_LIB_VERTEX_ARRAY_H

#include <fennec/renderers/opengl/lib/fwd.h>
#include <fennec/renderers/opengl/lib/enum.h>

namespace fennec
{

namespace gl
{

class vertex_array {
public:
	constexpr vertex_array()
		: _handle(NULL) {
		glGenVertexArrays(1, &_handle);
	}

	constexpr ~vertex_array() {
		glDeleteVertexArrays(1, &_handle);
	}

	constexpr void start() const {
		glBindVertexArray(_handle);
	}

	constexpr void end() const {
		glBindVertexArray(NULL);
	}

	constexpr void set_attribute(GLuint i, GLenum type, GLint n, GLintptr offset, GLboolean normalized = false) {
		glVertexAttribFormat(i, n, type, normalized, offset);
		glEnableVertexAttribArray(i);
	}

	constexpr void clear_attribute(GLuint i) {
		glDisableVertexAttribArray(i);
	}

private:
	GLuint _handle;
};

}

}

#endif // FENNEC_RENDERERS_OPENGL_LIB_VERTEX_ARRAY_H
